<?
use Tygh\Registry;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

require_once(dirname(__FILE__) . '/iretailapi.php');

function fn_iretail_finish_payment($order_id, $pp_response, $force_notification = array())
{
	if ($pp['order_status'] == 'P')
		fn_iretail_order2iretail($order_id,false);
}


function fn_iretail_settions_logfile()
{
	ob_start();
	?>
	<div class="clearfix">
		<h4 class="pull-left">Файл журнала</h4>
		<div class="pull-left" style="margin:5px 0 0 30px;">
			<a href="<?=fn_url("iretail.clearlog")?>" class="btn btn-warning cm-post"><i class="icon-remove"></i> Очистить журнал</a></div>
	</div>
	<div class="well" style="margin-top:10px;max-width:80%;max-height:500px;overflow:auto;white-space: pre-wrap;"><?
		$l=IRetailAPI::getLog();
		if (trim($l))
			echo htmlspecialchars($l);
		else
			echo 'Журнал пуст';
	?></div>
	
	<?
	$content=ob_get_clean();
	return $content;
}

class SCIretailMailer implements IretailMailerInterface {
	use IretailMailerTrait;

	function notify($subject, $message)
	{
		foreach ($this->emails as $e)
    {
      Tygh::$app['mailer']->send(array(
          'to' => $e,
          'from' => 'default_company_orders_department',
          'subject' => $subject,
          'body' => $message,
      ));
    }		
	}

}


IRetailApi::config([
	'debug'=>1,
	'power'=>1,
	'mode'=>Registry::get('addons.iretail.mode'),
	'log'=>Registry::get('addons.iretail.log'),
	'login'=>Registry::get('addons.iretail.login'),
	'apikey'=>Registry::get('addons.iretail.apikey'),
	'printmode'=>Registry::get('addons.iretail.printmode'),
	'notifymode'=>Registry::get('addons.iretail.notifymode'),
	'mailer'=>new SCIretailMailer(Registry::get('addons.iretail.emails')),
]);

function fn_iretail_order2iretail($order_id,$refund=false)
{

  $order_info = fn_get_order_info((int)$order_id, false, false, false, false);
  // fn_print_r($order_info);
  $data = [
    'external_order_id' => $order_info['order_id'],
    'external_order_time' => gmdate('Y-m-d H:i:s',$order_info['timestamp']),
    'date_time' => gmdate('Y-m-d H:i:s',$order_info['timestamp']),
    // 'mode' => 'print_email', по настройке
    'type' => $refund?'refund':'payment',
    'customer_phone' => $order_info['b_phone'],
    'customer_email' => $order_info['email'],
    'card_amount' => $order_info['total'],
    // 'cash_amount' => 0,
    // 'mc_amount' => 0,
    'purchase' => ['products' => []],
  ];  

  foreach ($order_info['products'] as $k=>$p)
    if ($p['amount']!=0)
    {
    	$d=[
    		'name'=>$p['product'],
    		'quantity'=>$p['amount'],
    		'price'=>round($p['display_subtotal']/$p['amount'],2),
      ];  	
      if (isset($order_info['taxes']))
      	foreach ($order_info['taxes'] as $t)
      		if (isset($t['applies']['items']['P'][$k]) && $t['applies']['items']['P'][$k])
      			$d['vat']=round($t['rate_value']/100,2);
      $data['purchase']['products'][]=$d;
    }

  foreach ($order_info['shipping'] as $k=>$s)
    if ($s['rate']!=0)
    {
    	$d=[
    		'name'=>'Доставка - '.$s['shipping'],
    		'quantity'=>1,
    		'price'=>$s['rate'],
      ];  	
      if (isset($s['taxes']) && is_array($s['taxes']))
      	$d['vat']=round(reset($s['taxes'])['rate_value']/100);
      $data['purchase']['products'][]=$d;
    }

  $ret=IRetailAPI::request($data);
	
	return $ret['status']=="OK";
}
    